#ifndef WTRUNTIME_IOCALL_H
#define WTRUNTIME_IOCALL_H

#include "config.h"
#include "types.h"

struct wtr_context;

void wtr_iocall_writestdout(struct wtr_context* const ctx, const char* str,
	wt_u32 len);
void wtr_iocall_readlnstdin(struct wtr_context* const ctx, char sep);
void wtr_iocall_access(struct wtr_context* const ctx, const char* pathname,
	wt_u32 mode);
void wtr_iocall_stat(struct wtr_context* const ctx, const char* pathname);
void wtr_iocall_fstat(struct wtr_context* const ctx, wt_file file);
void wtr_iocall_fopen(struct wtr_context* const ctx, const char* pathname,
	char mode);
void wtr_iocall_fclose(struct wtr_context* const ctx, wt_file file);
void wtr_iocall_fseek(struct wtr_context* const ctx, wt_file file,
	wt_i64 offset, wt_u32 whence);
void wtr_iocall_feof(struct wtr_context* const ctx, wt_file file);
void wtr_iocall_fwrite(struct wtr_context* const ctx, wt_file file,
	const char* buf, wt_u32 len, int pop_and_check_return_value);
void wtr_iocall_fwriteln(struct wtr_context* const ctx, wt_file file,
	const char* buf, wt_u32 len, char sep);
void wtr_iocall_fread(struct wtr_context* const ctx, wt_file file,
	char* buf, wt_u32 maxlen, int pop_and_check_return_value);
void wtr_iocall_freadln(struct wtr_context* const ctx, wt_file file,
	char* buf, wt_u32 maxlen, char sep);
void wtr_iocall_opendir(struct wtr_context* const ctx, const char* pathname);
void wtr_iocall_closedir(struct wtr_context* const ctx, wt_dir dir);
void wtr_iocall_readdir(struct wtr_context* const ctx, wt_dir dir);
void wtr_iocall_dirgettype(struct wtr_context* const ctx, wt_dir dir);
void wtr_iocall_dirgetname(struct wtr_context* const ctx, wt_dir dir,
	char* buf, wt_u32 maxlen);

#endif /* WTRUNTIME_IOCALL_H */
